# Google Cloud Spanner v1 API - Class PartitionQueryRequest (5.13.0-beta07)

5.13.0-beta07 5.13.0-beta06 5.12.0 (latest) 5.11.0 5.10.0 5.9.0 5.8.0 5.7.0 5.6.0 5.5.0 5.4.0 5.3.0 5.2.0 5.1.0 5.0.0 4.6.0 4.5.0 4.4.0 4.3.0 4.2.0 4.1.0 4.0.0 3.15.1 3.14.0 3.13.0 3.12.0 3.11.0 3.10.0 3.9.0 3.8.0 3.7.0 3.6.0 3.5.0

    public sealed class PartitionQueryRequest : IMessage<PartitionQueryRequest>, IEquatable<PartitionQueryRequest>, IDeepCloneable<PartitionQueryRequest>, IBufferMessage, IMessage

Reference documentation and code samples for the Google Cloud Spanner v1 API class PartitionQueryRequest.

The request for \[PartitionQuery\]\[google.spanner.v1.Spanner.PartitionQuery\]

## Inheritance

[object](https://learn.microsoft.com/dotnet/api/system.object) \> PartitionQueryRequest

## Implements

[IMessage](https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.IMessage-1.html)[PartitionQueryRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.PartitionQueryRequest), [IEquatable](https://learn.microsoft.com/dotnet/api/system.iequatable-1)[PartitionQueryRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.PartitionQueryRequest), [IDeepCloneable](https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.IDeepCloneable-1.html)[PartitionQueryRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.PartitionQueryRequest), [IBufferMessage](https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.IBufferMessage.html), [IMessage](https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.IMessage.html)

## Inherited Members

[object.GetHashCode()](https://learn.microsoft.com/dotnet/api/system.object.gethashcode) [object.GetType()](https://learn.microsoft.com/dotnet/api/system.object.gettype) [object.ToString()](https://learn.microsoft.com/dotnet/api/system.object.tostring)

## Namespace

[Google.Cloud.Spanner.V1](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1)

## Assembly

Google.Cloud.Spanner.V1.dll

## Constructors

### PartitionQueryRequest()

    public PartitionQueryRequest()

### PartitionQueryRequest(PartitionQueryRequest)

    public PartitionQueryRequest(PartitionQueryRequest other)

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `other` | `https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.PartitionQueryRequest` |

## Properties

### ParamTypes

    public MapField<string, Type> ParamTypes { get; }

Optional. It isn't always possible for Cloud Spanner to infer the right SQL
type from a JSON value. For example, values of type `BYTES` and values of
type `STRING` both appear in
\[params\]\[google.spanner.v1.PartitionQueryRequest.params\] as JSON strings.

In these cases, `param_types` can be used to specify the exact
SQL type for some or all of the SQL query parameters. See the
definition of \[Type\]\[google.spanner.v1.Type\] for more information
about SQL types.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.Collections.MapField-2.htmlhttps://learn.microsoft.com/dotnet/api/system.stringhttps://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.Type` |   |

### Params

    public Struct Params { get; set; }

Optional. Parameter names and values that bind to placeholders in the SQL
string.

A parameter placeholder consists of the `@` character followed by the
parameter name (for example, `@firstName`). Parameter names can contain
letters, numbers, and underscores.

Parameters can appear anywhere that a literal value is expected. The same
parameter name can be used more than once, for example:

`"WHERE id > @msg_id AND id < @msg_id + 100"`

It's an error to execute a SQL statement with unbound parameters.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.WellKnownTypes.Struct.html` |   |

### PartitionOptions

    public PartitionOptions PartitionOptions { get; set; }

Additional options that affect how many partitions are created.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.PartitionOptions` |   |

### Session

    public string Session { get; set; }

Required. The session used to create the partitions.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://learn.microsoft.com/dotnet/api/system.string` |   |

### SessionAsSessionName

    public SessionName SessionAsSessionName { get; set; }

[SessionName](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.SessionName)-typed view over the [Session](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.PartitionQueryRequest#Google_Cloud_Spanner_V1_PartitionQueryRequest_Session) resource name property.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.SessionName` |   |

### Sql

    public string Sql { get; set; }

Required. The query request to generate partitions for. The request fails
if the query isn't root partitionable. For a query to be root
partitionable, it needs to satisfy a few conditions. For example, if the
query execution plan contains a distributed union operator, then it must be
the first operator in the plan. For more information about other
conditions, see [Read data in
parallel](https://cloud.google.com/spanner/docs/reads#read_data_in_parallel).

The query request must not contain DML commands, such as `INSERT`,
`UPDATE`, or `DELETE`. Use
\[`ExecuteStreamingSql`\]\[google.spanner.v1.Spanner.ExecuteStreamingSql\] with
a `PartitionedDml` transaction for large, partition-friendly DML
operations.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://learn.microsoft.com/dotnet/api/system.string` |   |

### Transaction

    public TransactionSelector Transaction { get; set; }

Read-only snapshot transactions are supported, read and write and
single-use transactions are not.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Spanner.V1/latest/Google.Cloud.Spanner.V1.TransactionSelector` |   |